#!/bin/sh

#UFHi v0.35
#@ichinomoto

_FUNCTIONS=/etc/rc.d/functions
[ -f ${_FUNCTIONS} ] && . ${_FUNCTIONS}

. /etc/sysconfig/mntus


_EIPUTS=/usr/sbin/eiputs
[ -f ${_EIPUTS} ] && . ${_EIPUTS}

EIPS_SPACES="                                           "
EIPS_BASE_X=4
EIPS_BASE_Y=32

VERSION="0.35"
FILE_VERSION="035"

MD5LIST=/var/tmp/rootfs_md5_list

#
eips $EIPS_BASE_X $EIPS_BASE_Y "${EIPS_SPACES}"
eips $EIPS_BASE_X $EIPS_BASE_Y "install UFHi+pdf_download_hack $VERSION"
echo "install UFHi+pdf_download_hack $VRESION" > /mnt/us/UFHi_install.log

#UFHCXg[mF@ύX
#tHgւ̃N邩mF
if [ -e "/usr/java/lib/fonts/Serif_Regular.ttf" ];then
#if [ -l "/usr/java/lib/fonts/Serif_Regular.ttf" ];then
  #ꍇ̓CXg[~
  eips $EIPS_BASE_X $((EIPS_BASE_Y + 2)) "${EIPS_SPACES}"
  eips $EIPS_BASE_X $((EIPS_BASE_Y + 2)) "CUSTOM FONT LINK FOUND"
  echo "CUSTOM FONT LINK FOUND" >> /mnt/us/UFHi_install.log

  eips $EIPS_BASE_X $((EIPS_BASE_Y + 3)) "${EIPS_SPACES}"
  eips $EIPS_BASE_X $((EIPS_BASE_Y + 3)) "PREASE UNINSTALL OTHER UFH FIRST"
  echo "PREASE UNINSTALL OTHER UFH FIRST" >> /mnt/us/UFHi_install.log

  eips $EIPS_BASE_X $((EIPS_BASE_Y + 4)) "${EIPS_SPACES}"
  eips $EIPS_BASE_X $((EIPS_BASE_Y + 5)) "UFHi install FAILED"
  echo "UFHi install FAILED" >> /mnt/us/UFHi_install.log

  rm ${MNTUS_MP}/*.bin
  return 0
else

  update_progressbar 2
  
  #fBNgobNAbvƐVK쐬
  if [ -e /mnt/us/system/fonts ];then
    mv /mnt/us/system/fonts /mnt/us/system/old_fonts
  fi

  mkdir -p /mnt/us/system/fonts/original
  
  #IWitHg̏o
  eips $EIPS_BASE_X $((EIPS_BASE_Y + 1)) "${EIPS_SPACES}"
  eips $EIPS_BASE_X $((EIPS_BASE_Y + 1)) "backup original fonts:"

  #SansMono̓ftHg̕g
  cp /usr/java/lib/fonts/*.ttf /mnt/us/system/fonts/original
  if [ ! -e /mnt/us/system/fonts/Sans_Regular.ttf ];then
    cp /mnt/us/system/fonts/original/Helvetica_LT_65_Medium.ttf /mnt/us/system/fonts/Sans_Regular.ttf
  fi
  if [ ! -e /mnt/us/system/fonts/Sans_Italic.ttf ];then
    cp /mnt/us/system/fonts/original/Helvetica_LT_66_Medium_Italic.ttf /mnt/us/system/fonts/Sans_Italic.ttf
  fi
  if [ ! -e /mnt/us/system/fonts/Sans_Bold.ttf ];then
    cp /mnt/us/system/fonts/original/Helvetica_LT_75_Bold.ttf /mnt/us/system/fonts/Sans_Bold.ttf
  fi
  if [ ! -e /mnt/us/system/fonts/Sans_BoldItalic.ttf ];then
    cp /mnt/us/system/fonts/original/Helvetica_LT_76_Bold_Italic.ttf /mnt/us/system/fonts/Sans_BoldItalic.ttf
  fi
  if [ ! -e /mnt/us/system/fonts/Mono_Regular.ttf ];then
    cp /mnt/us/system/fonts/original/KindleBlackboxRegular.ttf /mnt/us/system/fonts/Mono_Regular.ttf
  fi
  if [ ! -e /mnt/us/system/fonts/Mono_Italic.ttf ];then
    cp /mnt/us/system/fonts/original/KindleBlackboxItalic.ttf /mnt/us/system/fonts/Mono_Italic.ttf
  fi
  if [ ! -e /mnt/us/system/fonts/Mono_Bold.ttf ];then
    cp /mnt/us/system/fonts/original/KindleBlackboxBold.ttf /mnt/us/system/fonts/Mono_Bold.ttf
  fi
  if [ ! -e /mnt/us/system/fonts/Mono_BoldItalic.ttf ];then
    cp /mnt/us/system/fonts/original/KindleBlackboxBoldItalic.ttf /mnt/us/system/fonts/Mono_BoldItalic.ttf
  fi

  eips $EIPS_BASE_X $((EIPS_BASE_Y + 1)) "backup original fonts: done"
  echo "backup original fonts: done" >> /mnt/us/UFHi_install.log
  
  update_progressbar 10
  
  #Serif̂݃JX^tHg̃Rs[
  eips $EIPS_BASE_X $((EIPS_BASE_Y + 2)) "${EIPS_SPACES}"
  eips $EIPS_BASE_X $((EIPS_BASE_Y + 2)) "copy custom fonts:"
  if [ ! -e /mnt/us/system/fonts/Serif_Regular.ttf ];then
    cp /mnt/us/fonthack/Serif_Regular.ttf /mnt/us/system/fonts/Serif_Regular.ttf
  fi
  if [ ! -e /mnt/us/system/fonts/Serif_Italic.ttf ];then
    cp /mnt/us/fonthack/Serif_Regular.ttf /mnt/us/system/fonts/Serif_Italic.ttf
  fi
  if [ ! -e /mnt/us/system/fonts/Serif_Bold.ttf ];then
    cp /mnt/us/fonthack/Serif_Regular.ttf /mnt/us/system/fonts/Serif_Bold.ttf
  fi
  if [ ! -e /mnt/us/system/fonts/Serif_BoldItalic.ttf ];then
    cp /mnt/us/fonthack/Serif_Regular.ttf /mnt/us/system/fonts/Serif_BoldItalic.ttf
  fi
  
  update_progressbar 30
  
  #JX^tHg̃N쐬
  ln -s /mnt/us/system/fonts/Serif*.ttf /usr/java/lib/fonts/
  ln -s /mnt/us/system/fonts/Sans*.ttf /usr/java/lib/fonts/
  ln -s /mnt/us/system/fonts/Mono*.ttf /usr/java/lib/fonts/
  
  eips $EIPS_BASE_X $((EIPS_BASE_Y + 2)) "copy custom fonts: done"
  echo "copy custom fonts: done" >> /mnt/us/UFHi_install.log
  
  update_progressbar 40
  
  #tHgݒt@CobNAbvƒu
  eips $EIPS_BASE_X $((EIPS_BASE_Y + 3)) "${EIPS_SPACES}"
  eips $EIPS_BASE_X $((EIPS_BASE_Y + 3)) "backup & update setting files:"

  cp /usr/java/lib/font.properties /mnt/us/system/fonts/original/font.properties
  echo "backup file     `md5sum /mnt/us/system/fonts/original/font.properties`" > /mnt/us/system/fonts/original/font.properties_md5sum
  echo "system original `grep font.properties $MD5LIST`" >> /mnt/us/system/fonts/original/font.properties_md5sum

  #font.properties
  sed -i -e "s/Caecilia_LT_65_Medium\.ttf/Serif_Regular\.ttf/" /usr/java/lib/font.properties
  sed -i -e "s/Caecilia_LT_75_Bold\.ttf/Serif_Bold\.ttf/" /usr/java/lib/font.properties
  sed -i -e "s/Caecilia_LT_66_Medium_Italic\.ttf/Serif_Italic\.ttf/" /usr/java/lib/font.properties
  sed -i -e "s/Caecilia_LT_76_Bold_Italic\.ttf/Serif_BoldItalic\.ttf/" /usr/java/lib/font.properties
  sed -i -e "s/Helvetica_LT_65_Medium\.ttf/Sans_Regular\.ttf/" /usr/java/lib/font.properties
  sed -i -e "s/Helvetica_LT_75_Bold\.ttf/Sans_Bold\.ttf/" /usr/java/lib/font.properties
  sed -i -e "s/Helvetica_LT_66_Medium_Italic\.ttf/Sans_Italic\.ttf/" /usr/java/lib/font.properties
  sed -i -e "s/Helvetica_LT_76_Bold_Italic\.ttf/Sans_BoldItalic\.ttf/" /usr/java/lib/font.properties
  sed -i -e "s/KindleBlackboxRegular\.ttf/Mono_Regular\.ttf/" /usr/java/lib/font.properties
  sed -i -e "s/KindleBlackboxBold\.ttf/Mono_Bold\.ttf/" /usr/java/lib/font.properties
  sed -i -e "s/KindleBlackboxItalic\.ttf/Mono_Italic\.ttf/" /usr/java/lib/font.properties
  sed -i -e "s/KindleBlackboxBoldItalic\.ttf/Mono_BoldItalic\.ttf/" /usr/java/lib/font.properties
  
  update_progressbar 70
  
  #uEUpݒt@CobNAbvƒu
  if [ ! -e /opt/amazon/ebook/config/netfront.ini.ufhi_bak ];then
    cp /opt/amazon/ebook/config/netfront.ini /mnt/us/system/fonts/original/netfront.ini
    echo "backup file     `md5sum /mnt/us/system/fonts/original/netfront.ini`" > /mnt/us/system/fonts/original/netfront.ini_md5sum
    echo "system original `grep netfront.ini $MD5LIST`" >> /mnt/us/system/fonts/original/netfront.ini_md5sum
  fi

  #netfront.ini
  sed -i -e "s/Caecilia_LT_65_Medium\.ttf/Serif_Regular\.ttf/" /opt/amazon/ebook/config/netfront.ini
  sed -i -e "s/Caecilia_LT_75_Bold\.ttf/Serif_Bold\.ttf/" /opt/amazon/ebook/config/netfront.ini
  sed -i -e "s/Caecilia_LT_66_Medium_Italic\.ttf/Serif_Italic\.ttf/" /opt/amazon/ebook/config/netfront.ini
  sed -i -e "s/Caecilia_LT_76_Bold_Italic\.ttf/Serif_BoldItalic\.ttf/" /opt/amazon/ebook/config/netfront.ini
  sed -i -e "s/Helvetica_LT_65_Medium\.ttf/Sans_Regular\.ttf/" /opt/amazon/ebook/config/netfront.ini
  sed -i -e "s/Helvetica_LT_75_Bold\.ttf/Sans_Bold\.ttf/" /opt/amazon/ebook/config/netfront.ini
  sed -i -e "s/Helvetica_LT_66_Medium_Italic\.ttf/Sans_Italic\.ttf/" /opt/amazon/ebook/config/netfront.ini
  sed -i -e "s/Helvetica_LT_76_Bold_Italic\.ttf/Sans_BoldItalic\.ttf/" /opt/amazon/ebook/config/netfront.ini
  sed -i -e "s/KindleBlackboxRegular\.ttf/Mono_Regular\.ttf/" /opt/amazon/ebook/config/netfront.ini
  sed -i -e "s/KindleBlackboxBold\.ttf/Mono_Bold\.ttf/" /opt/amazon/ebook/config/netfront.ini
  sed -i -e "s/KindleBlackboxItalic\.ttf/Mono_Italic\.ttf/" /opt/amazon/ebook/config/netfront.ini
  sed -i -e "s/KindleBlackboxBoldItalic\.ttf/Mono_BoldItalic\.ttf/" /opt/amazon/ebook/config/netfront.ini
  sed -i -e "s/dlexts=prc mobi txt azw azw1/dlexts=prc mobi txt azw azw1 pdf zip/" /opt/amazon/ebook/config/netfront.ini
  sed -i -e "s/dlmimes=application\/x-mobipocket-ebook text\/x-prc application\/octet-stream text\/plain/dlmimes=application\/x-mobipocket-ebook text\/x-prc application\/octet-stream text\/plain application\/pdf/" /opt/amazon/ebook/config/netfront.ini
  
  eips $EIPS_BASE_X $((EIPS_BASE_Y + 3)) "backup & update setting files: done"
  echo "backup & update setting files: done" >> /mnt/us/UFHi_install.log
  
  update_progressbar 80
  
  eips $EIPS_BASE_X $((EIPS_BASE_Y + 4)) "${EIPS_SPACES}"
  eips $EIPS_BASE_X $((EIPS_BASE_Y + 4)) "font_check script install:"

  #NtHg`FbNXNvg̓o^
  mv /mnt/us/fonthack/font_check /etc/init.d/font_check
  chmod 0755 /etc/init.d/font_check
  ln -s ../init.d/font_check /etc/rc5.d/S90font_check
  
  eips $EIPS_BASE_X $((EIPS_BASE_Y + 4)) "font_check script install: done"
  
  update_progressbar 90

  #screen_saverΉ
  eips $EIPS_BASE_X $((EIPS_BASE_Y + 5)) "${EIPS_SPACES}"
  eips $EIPS_BASE_X $((EIPS_BASE_Y + 5)) "screen_saver hack:"
  cp -fr /opt/amazon/screen_saver /mnt/us/system/
  mv /opt/amazon/screen_saver /opt/amazon/screen_saver_orig
  ln -s /mnt/us/system/screen_saver /opt/amazon/screen_saver
  eips $EIPS_BASE_X $((EIPS_BASE_Y + 5)) "${EIPS_SPACES}"
  eips $EIPS_BASE_X $((EIPS_BASE_Y + 5)) "screen_saver hack: done"
  
  #o[Wԍ
  echo "UFH0.3i + pdf_download_hack " > /mnt/us/system/UFHi_install.log
  echo "version$VERSION install: `date`" >> /mnt/us/system/UFHi_install.log
  
  update_progressbar 95
  
  #o[W
  cp /etc/prettyversion.txt /mnt/us/system/fonts/original/prettyversion.txt
  echo "backup file     `md5sum /etc/prettyversion.txt`" > /mnt/us/system/fonts/original/prettyversion.txt_md5sum
  echo "system original `grep prettyversion.txt $MD5LIST`" >> /mnt/us/system/fonts/original/prettyversion.txt_md5sum
  sed -i -e "s/)/) + UFHi $VERSION/" /etc/prettyversion.txt
  
  update_progressbar 98

#  cp update_ufh_icustom+p_uninstall_$FILE_VERSION.bin /mnt/us/uninstaller/

  eips $EIPS_BASE_X $((EIPS_BASE_Y + 7)) "${EIPS_SPACES}"
  eips $EIPS_BASE_X $((EIPS_BASE_Y + 7)) "UFHi install SUCCESS"
  echo "UFHi install SUCCESS" >> /mnt/us/UFHi_install.log

fi

#################################################
## Remove all bundle files from the userstore
#################################################

  update_progressbar 100

  sleep 3

return 0
